/*******************************************************************
 *
 *	File:		Game.h
 *
 *	Author:		Peter van Sebille (peter@yipton.net)
 *
 *	(c) Copyright 2001, Peter van Sebille
 *	All Rights Reserved
 *
 *******************************************************************/

#ifndef __GAME_H
#define __GAME_H

#ifdef __WINS__
/* Turn off type mismatch warnings */
#pragma warning (disable:4244)
#pragma warning (disable:4761)
#pragma warning (disable:4018)
#pragma warning (disable:4101)
#pragma warning (disable:4146)
#pragma warning (disable:4068)
#pragma warning (disable:4005)
#pragma warning (disable:4305)
#pragma warning (disable:4100)
#pragma warning (disable:4510)
#pragma warning (disable:4512)
#pragma warning (disable:4610)
#endif


#define HEREL2(l)	#l
#define HEREL1(l)	HEREL2(l)
#define HERE_STR   __FILE__ "(" HEREL1(__LINE__) ") : "
#define HERE(m)	TPtrC((const TText *) HERE_STR m)



#ifdef __cplusplus
extern "C" {
#endif

void EDoomDebugPrint(const char*, ...);

#ifdef __cplusplus
}
#endif


#if 1
#define DPRINT(x) EDoomDebugPrint x;
#else
#define DPRINT(x)
#endif

void Oops();


#ifdef _DEBUG
	#ifdef __WINS__
		#define GAME_DEBUGGER_ALWAYS() _asm int 3
	#else
		#define GAME_DEBUGGER_ALWAYS()
	#endif

	#ifdef __xWINS__
		#define DEBUGGER() _asm int 3
	#else /* __WINS__ */
		#define DEBUGGER()
	#endif
#else /* _DEBUG */
	#define DEBUGGER()
	#define GAME_DEBUGGER_ALWAYS()
#endif



// simple debugging tool for target
#ifdef __MARM__

#ifdef __cplusplus
extern "C" { void DebugPrint(const char* str, int sec);}
#endif

#define DPRINT_WAIT(str, sec) DebugPrint(str, sec)
#else

#define DPRINT_WAIT(des, sec);

#endif

#endif /* __GAME_H */
