#ifndef PROFILER_H
#define PROFILER_H

/* profiling */
enum {
	PROFILER_END = -1,
	PROFILER_1 = 0,
	PROFILER_2,
	PROFILER_3,
	PROFILER_4,
	PROFILER_5,
	PROFILER_6,
	PROFILER_7,
	PROFILER_8,
	PROFILER_9,
	PROFILER_10,
	PROFILER_PROFILER,
	PROFILER_TOTAL
};


/*
To start profiling a certain section, e.g. video:
profiler_mark(PROFILER_VIDEO);

to end profiling the current section:
profiler_mark(PROFILER_END);

the profiler handles a FILO list so calls may be nested.
*/

//#define __USE_PROFILER 1
#undef __USE_PROFILER
#ifdef __USE_PROFILER
#define PROFILER_MARK(p)	profiler_mark(p)
#define PROFILER_SHOW		profiler_show
#else
#define PROFILER_MARK(p)
#define PROFILER_SHOW()
#endif

void profiler_mark(int type);
void profiler_start(void);
void profiler_stop(void);
void profiler_show(void);

int osd_cycles();

#endif	/* PROFILER_H */
